diff --git a/src/qml/qml/qqmlvmemetaobject.cpp b/src/qml/qml/qqmlvmemetaobject.cpp
index aed5f5af3..7f1c309ba 100644
--- a/src/qml/qml/qqmlvmemetaobject.cpp
+++ b/src/qml/qml/qqmlvmemetaobject.cpp
@@ -270,14 +270,17 @@ QAbstractDynamicMetaObject *QQmlInterceptorMetaObject::toDynamicMetaObject(QObje
     return this;
 }
 
-QQmlVMEMetaObject::QQmlVMEMetaObject(QObject *obj,
+QQmlVMEMetaObject::QQmlVMEMetaObject(QV4::ExecutionEngine *engine,
+                                     QObject *obj,
                                      QQmlPropertyCache *cache,
                                      const QQmlVMEMetaData *meta)
     : QQmlInterceptorMetaObject(obj, cache),
+      engine(engine),
       ctxt(QQmlData::get(obj, true)->outerContext), metaData(meta),
       aliasEndpoints(0),
       methods(0)
 {
+    Q_ASSERT(engine);
     cache->addref();
 
     QQmlData::get(obj)->hasVMEMetaObject = true;
@@ -353,56 +356,56 @@ void QQmlVMEMetaObject::writeProperty(int id, const QString& v)
 {
     QV4::MemberData *md = propertiesAsMemberData();
     if (md)
-        *(md->data() + id) = cache->engine->newString(v);
+        *(md->data() + id) = engine->newString(v);
 }
 
 void QQmlVMEMetaObject::writeProperty(int id, const QUrl& v)
 {
     QV4::MemberData *md = propertiesAsMemberData();
     if (md)
-        *(md->data() + id) = cache->engine->newVariantObject(QVariant::fromValue(v));
+        *(md->data() + id) = engine->newVariantObject(QVariant::fromValue(v));
 }
 
 void QQmlVMEMetaObject::writeProperty(int id, const QDate& v)
 {
     QV4::MemberData *md = propertiesAsMemberData();
     if (md)
-        *(md->data() + id) = cache->engine->newVariantObject(QVariant::fromValue(v));
+        *(md->data() + id) = engine->newVariantObject(QVariant::fromValue(v));
 }
 
 void QQmlVMEMetaObject::writeProperty(int id, const QDateTime& v)
 {
     QV4::MemberData *md = propertiesAsMemberData();
     if (md)
-        *(md->data() + id) = cache->engine->newVariantObject(QVariant::fromValue(v));
+        *(md->data() + id) = engine->newVariantObject(QVariant::fromValue(v));
 }
 
 void QQmlVMEMetaObject::writeProperty(int id, const QPointF& v)
 {
     QV4::MemberData *md = propertiesAsMemberData();
     if (md)
-        *(md->data() + id) = cache->engine->newVariantObject(QVariant::fromValue(v));
+        *(md->data() + id) = engine->newVariantObject(QVariant::fromValue(v));
 }
 
 void QQmlVMEMetaObject::writeProperty(int id, const QSizeF& v)
 {
     QV4::MemberData *md = propertiesAsMemberData();
     if (md)
-        *(md->data() + id) = cache->engine->newVariantObject(QVariant::fromValue(v));
+        *(md->data() + id) = engine->newVariantObject(QVariant::fromValue(v));
 }
 
 void QQmlVMEMetaObject::writeProperty(int id, const QRectF& v)
 {
     QV4::MemberData *md = propertiesAsMemberData();
     if (md)
-        *(md->data() + id) = cache->engine->newVariantObject(QVariant::fromValue(v));
+        *(md->data() + id) = engine->newVariantObject(QVariant::fromValue(v));
 }
 
 void QQmlVMEMetaObject::writeProperty(int id, QObject* v)
 {
     QV4::MemberData *md = propertiesAsMemberData();
     if (md)
-        *(md->data() + id) = QV4::QObjectWrapper::wrap(cache->engine, v);
+        *(md->data() + id) = QV4::QObjectWrapper::wrap(engine, v);
 
     QQmlVMEVariantQObjectPtr *guard = getQObjectGuardForProperty(id);
     if (v && !guard) {
@@ -419,7 +422,7 @@ int QQmlVMEMetaObject::readPropertyAsInt(int id)
     if (!md)
         return 0;
 
-    QV4::Scope scope(cache->engine);
+    QV4::Scope scope(engine);
     QV4::ScopedValue sv(scope, *(md->data() + id));
     if (!sv->isInt32())
         return 0;
@@ -432,7 +435,7 @@ bool QQmlVMEMetaObject::readPropertyAsBool(int id)
     if (!md)
         return false;
 
-    QV4::Scope scope(cache->engine);
+    QV4::Scope scope(engine);
     QV4::ScopedValue sv(scope, *(md->data() + id));
     if (!sv->isBoolean())
         return false;
@@ -445,7 +448,7 @@ double QQmlVMEMetaObject::readPropertyAsDouble(int id)
     if (!md)
         return 0.0;
 
-    QV4::Scope scope(cache->engine);
+    QV4::Scope scope(engine);
     QV4::ScopedValue sv(scope, *(md->data() + id));
     if (!sv->isDouble())
         return 0.0;
@@ -458,7 +461,7 @@ QString QQmlVMEMetaObject::readPropertyAsString(int id)
     if (!md)
         return QString();
 
-    QV4::Scope scope(cache->engine);
+    QV4::Scope scope(engine);
     QV4::ScopedValue sv(scope, *(md->data() + id));
     if (!sv->isString())
         return QString();
@@ -471,7 +474,7 @@ QUrl QQmlVMEMetaObject::readPropertyAsUrl(int id)
     if (!md)
         return QUrl();
 
-    QV4::Scope scope(cache->engine);
+    QV4::Scope scope(engine);
     QV4::ScopedValue sv(scope, *(md->data() + id));
     const QV4::VariantObject *v = sv->as<QV4::VariantObject>();
     if (!v || v->d()->data.type() != QVariant::Url)
@@ -485,7 +488,7 @@ QDate QQmlVMEMetaObject::readPropertyAsDate(int id)
     if (!md)
         return QDate();
 
-    QV4::Scope scope(cache->engine);
+    QV4::Scope scope(engine);
     QV4::ScopedValue sv(scope, *(md->data() + id));
     const QV4::VariantObject *v = sv->as<QV4::VariantObject>();
     if (!v || v->d()->data.type() != QVariant::Date)
@@ -499,7 +502,7 @@ QDateTime QQmlVMEMetaObject::readPropertyAsDateTime(int id)
     if (!md)
         return QDateTime();
 
-    QV4::Scope scope(cache->engine);
+    QV4::Scope scope(engine);
     QV4::ScopedValue sv(scope, *(md->data() + id));
     const QV4::VariantObject *v = sv->as<QV4::VariantObject>();
     if (!v || v->d()->data.type() != QVariant::DateTime)
@@ -513,7 +516,7 @@ QSizeF QQmlVMEMetaObject::readPropertyAsSizeF(int id)
     if (!md)
         return QSizeF();
 
-    QV4::Scope scope(cache->engine);
+    QV4::Scope scope(engine);
     QV4::ScopedValue sv(scope, *(md->data() + id));
     const QV4::VariantObject *v = sv->as<QV4::VariantObject>();
     if (!v || v->d()->data.type() != QVariant::SizeF)
@@ -527,7 +530,7 @@ QPointF QQmlVMEMetaObject::readPropertyAsPointF(int id)
     if (!md)
         return QPointF();
 
-    QV4::Scope scope(cache->engine);
+    QV4::Scope scope(engine);
     QV4::ScopedValue sv(scope, *(md->data() + id));
     const QV4::VariantObject *v = sv->as<QV4::VariantObject>();
     if (!v || v->d()->data.type() != QVariant::PointF)
@@ -541,7 +544,7 @@ QObject* QQmlVMEMetaObject::readPropertyAsQObject(int id)
     if (!md)
         return 0;
 
-    QV4::Scope scope(cache->engine);
+    QV4::Scope scope(engine);
     QV4::ScopedValue sv(scope, *(md->data() + id));
     const QV4::QObjectWrapper *wrapper = sv->as<QV4::QObjectWrapper>();
     if (!wrapper)
@@ -555,11 +558,11 @@ QList<QObject *> *QQmlVMEMetaObject::readPropertyAsList(int id)
     if (!md)
         return 0;
 
-    QV4::Scope scope(cache->engine);
+    QV4::Scope scope(engine);
     QV4::Scoped<QV4::VariantObject> v(scope, *(md->data() + id));
     if (!v || (int)v->d()->data.userType() != qMetaTypeId<QList<QObject *> >()) {
         QVariant variant(qVariantFromValue(QList<QObject*>()));
-        v = cache->engine->newVariantObject(variant);
+        v = engine->newVariantObject(variant);
         *(md->data() + id) = v;
     }
     return static_cast<QList<QObject *> *>(v->d()->data.data());
@@ -571,7 +574,7 @@ QRectF QQmlVMEMetaObject::readPropertyAsRectF(int id)
     if (!md)
         return QRectF();
 
-    QV4::Scope scope(cache->engine);
+    QV4::Scope scope(engine);
     QV4::ScopedValue sv(scope, *(md->data() + id));
     const QV4::VariantObject *v = sv->as<QV4::VariantObject>();
     if (!v || v->d()->data.type() != QVariant::RectF)
@@ -730,7 +733,7 @@ int QQmlVMEMetaObject::metaCall(QObject *o, QMetaObject::Call c, int _id, void *
                             if (md) {
                                 QV4::VariantObject *v = (md->data() + id)->as<QV4::VariantObject>();
                                 if (!v) {
-                                    *(md->data() + id) = cache->engine->newVariantObject(QVariant());
+                                    *(md->data() + id) = engine->newVariantObject(QVariant());
                                     v = (md->data() + id)->as<QV4::VariantObject>();
                                     QQml_valueTypeProvider()->initValueType(t, v->d()->data);
                                 }
@@ -909,7 +912,7 @@ QVariant QQmlVMEMetaObject::readPropertyAsVariant(int id)
         const QV4::VariantObject *v = (md->data() + id)->as<QV4::VariantObject>();
         if (v)
             return v->d()->data;
-        return cache->engine->toVariant(*(md->data() + id), -1);
+        return engine->toVariant(*(md->data() + id), -1);
     }
     return QVariant();
 }
@@ -969,8 +972,8 @@ void QQmlVMEMetaObject::writeProperty(int id, const QVariant &value)
 
         // And, if the new value is a scarce resource, we need to ensure that it does not get
         // automatically released by the engine until no other references to it exist.
-        QV4::Scope scope(cache->engine);
-        QV4::ScopedValue newv(scope, cache->engine->fromVariant(value));
+        QV4::Scope scope(engine);
+        QV4::ScopedValue newv(scope, engine->fromVariant(value));
         QV4::Scoped<QV4::VariantObject> v(scope, newv);
         if (!!v)
             v->addVmePropertyReference();
@@ -995,7 +998,7 @@ void QQmlVMEMetaObject::writeProperty(int id, const QVariant &value)
                                  v->d()->data != value);
                 if (v)
                     v->removeVmePropertyReference();
-                *(md->data() + id) = cache->engine->newVariantObject(value);
+                *(md->data() + id) = engine->newVariantObject(value);
                 v = static_cast<QV4::VariantObject *>(md->data() + id);
                 v->addVmePropertyReference();
             }
@@ -1102,15 +1105,13 @@ void QQmlVMEMetaObject::setVMEProperty(int index, const QV4::Value &v)
 
 void QQmlVMEMetaObject::ensureQObjectWrapper()
 {
-    Q_ASSERT(cache && cache->engine);
-    QV4::ExecutionEngine *v4 = cache->engine;
-    QV4::QObjectWrapper::wrap(v4, object);
+    Q_ASSERT(cache);
+    QV4::QObjectWrapper::wrap(engine, object);
 }
 
 void QQmlVMEMetaObject::mark(QV4::ExecutionEngine *e)
 {
-    QV4::ExecutionEngine *v4 = cache ? cache->engine : 0;
-    if (v4 != e)
+    if (engine != e)
         return;
 
     properties.markOnce(e);
@@ -1121,11 +1122,9 @@ void QQmlVMEMetaObject::mark(QV4::ExecutionEngine *e)
 
 void QQmlVMEMetaObject::allocateProperties()
 {
-    Q_ASSERT(cache && cache->engine);
     Q_ASSERT(!properties.valueRef());
-    QV4::ExecutionEngine *v4 = cache->engine;
-    QV4::Heap::MemberData *data = QV4::MemberData::allocate(v4, metaData->propertyCount);
-    properties.set(v4, data);
+    QV4::Heap::MemberData *data = QV4::MemberData::allocate(engine, metaData->propertyCount);
+    properties.set(engine, data);
     for (uint i = 0; i < data->size; ++i)
         data->data[i] = QV4::Encode::undefined();
 }
diff --git a/src/qml/qml/qqmlvmemetaobject_p.h b/src/qml/qml/qqmlvmemetaobject_p.h
index 7da44e3b8..fc43b8f23 100644
--- a/src/qml/qml/qqmlvmemetaobject_p.h
+++ b/src/qml/qml/qqmlvmemetaobject_p.h
@@ -195,7 +195,7 @@ class QQmlVMEMetaObjectEndpoint;
 class Q_QML_PRIVATE_EXPORT QQmlVMEMetaObject : public QQmlInterceptorMetaObject
 {
 public:
-    QQmlVMEMetaObject(QObject *obj, QQmlPropertyCache *cache, const QQmlVMEMetaData *data);
+    QQmlVMEMetaObject(QV4::ExecutionEngine *engine, QObject *obj, QQmlPropertyCache *cache, const QQmlVMEMetaData *data);
     ~QQmlVMEMetaObject();
 
     bool aliasTarget(int index, QObject **target, int *coreIndex, int *valueTypeIndex) const;
@@ -220,6 +220,7 @@ public:
     friend class QQmlVMEVariantQObjectPtr;
     friend class QQmlPropertyCache;
 
+    QV4::ExecutionEngine *engine;
     QQmlGuardedContextData ctxt;
 
     const QQmlVMEMetaData *metaData;
diff --git a/src/qml/types/qqmldelegatemodel.cpp b/src/qml/types/qqmldelegatemodel.cpp
index f2de91172..04c8bac00 100644
--- a/src/qml/types/qqmldelegatemodel.cpp
+++ b/src/qml/types/qqmldelegatemodel.cpp
@@ -927,7 +927,7 @@ QObject *QQmlDelegateModelPrivate::object(Compositor::Group group, int index, bo
     QQmlDelegateModelItem *cacheItem = it->inCache() ? m_cache.at(it.cacheIndex) : 0;
 
     if (!cacheItem) {
-        cacheItem = m_adaptorModel.createItem(m_cacheMetaType, m_context->engine(), it.modelIndex());
+        cacheItem = m_adaptorModel.createItem(m_cacheMetaType, it.modelIndex());
         if (!cacheItem)
             return 0;
 
@@ -1626,7 +1626,7 @@ bool QQmlDelegateModelPrivate::insert(Compositor::insert_iterator &before, const
     if (!m_context || !m_context->isValid())
         return false;
 
-    QQmlDelegateModelItem *cacheItem = m_adaptorModel.createItem(m_cacheMetaType, m_context->engine(), -1);
+    QQmlDelegateModelItem *cacheItem = m_adaptorModel.createItem(m_cacheMetaType, -1);
     if (!cacheItem)
         return false;
     if (!object.isObject())
@@ -2474,7 +2474,7 @@ QQmlV4Handle QQmlDelegateModelGroup::get(int index)
 
     if (!cacheItem) {
         cacheItem = model->m_adaptorModel.createItem(
-                model->m_cacheMetaType, model->m_context->engine(), it.modelIndex());
+                model->m_cacheMetaType, it.modelIndex());
         if (!cacheItem)
             return QQmlV4Handle(QV4::Encode::undefined());
         cacheItem->groups = it->flags;
diff --git a/src/qml/util/qqmladaptormodel.cpp b/src/qml/util/qqmladaptormodel.cpp
index c61144dd8..e291e7c70 100644
--- a/src/qml/util/qqmladaptormodel.cpp
+++ b/src/qml/util/qqmladaptormodel.cpp
@@ -513,16 +513,15 @@ public:
     QQmlDelegateModelItem *createItem(
             QQmlAdaptorModel &model,
             QQmlDelegateModelItemMetaType *metaType,
-            QQmlEngine *engine,
-            int index) const
+            int index) const Q_DECL_OVERRIDE
     {
         VDMAbstractItemModelDataType *dataType = const_cast<VDMAbstractItemModelDataType *>(this);
         if (!metaObject)
-            dataType->initializeMetaType(model, engine);
+            dataType->initializeMetaType(model);
         return new QQmlDMAbstractItemModelData(metaType, dataType, index);
     }
 
-    void initializeMetaType(QQmlAdaptorModel &model, QQmlEngine *engine)
+    void initializeMetaType(QQmlAdaptorModel &model)
     {
         QMetaObjectBuilder builder;
         setModelDataType<QQmlDMAbstractItemModelData>(&builder, this);
@@ -547,7 +546,7 @@ public:
 
         metaObject = builder.toMetaObject();
         *static_cast<QMetaObject *>(this) = *metaObject;
-        propertyCache = new QQmlPropertyCache(QV8Engine::getV4(engine), metaObject);
+        propertyCache = new QQmlPropertyCache(metaObject);
     }
 };
 
@@ -661,8 +660,7 @@ public:
     QQmlDelegateModelItem *createItem(
             QQmlAdaptorModel &model,
             QQmlDelegateModelItemMetaType *metaType,
-            QQmlEngine *,
-            int index) const
+            int index) const Q_DECL_OVERRIDE
     {
         return new QQmlDMListAccessorData(
                 metaType,
@@ -746,8 +744,7 @@ public:
     QQmlDelegateModelItem *createItem(
             QQmlAdaptorModel &model,
             QQmlDelegateModelItemMetaType *metaType,
-            QQmlEngine *,
-            int index) const
+            int index) const Q_DECL_OVERRIDE
     {
         VDMObjectDelegateDataType *dataType = const_cast<VDMObjectDelegateDataType *>(this);
         if (!metaObject)
diff --git a/src/qml/util/qqmladaptormodel_p.h b/src/qml/util/qqmladaptormodel_p.h
index 9da04462a..f7d79fc0c 100644
--- a/src/qml/util/qqmladaptormodel_p.h
+++ b/src/qml/util/qqmladaptormodel_p.h
@@ -76,7 +76,6 @@ public:
         virtual QQmlDelegateModelItem *createItem(
                 QQmlAdaptorModel &,
                 QQmlDelegateModelItemMetaType *,
-                QQmlEngine *,
                 int) const { return 0; }
 
         virtual bool notify(
@@ -116,8 +115,8 @@ public:
     inline int count() const { return qMax(0, accessors->count(*this)); }
     inline QVariant value(int index, const QString &role) const {
         return accessors->value(*this, index, role); }
-    inline QQmlDelegateModelItem *createItem(QQmlDelegateModelItemMetaType *metaType, QQmlEngine *engine, int index) {
-        return accessors->createItem(*this, metaType, engine, index); }
+    inline QQmlDelegateModelItem *createItem(QQmlDelegateModelItemMetaType *metaType, int index) {
+        return accessors->createItem(*this, metaType, index); }
     inline bool hasProxyObject() const {
         return list.type() == QQmlListAccessor::Instance || list.type() == QQmlListAccessor::ListProperty; }
 
diff --git a/src/quick/designer/qqmldesignermetaobject.cpp b/src/quick/designer/qqmldesignermetaobject.cpp
index 9ee814e1a..232ed960e 100644
--- a/src/quick/designer/qqmldesignermetaobject.cpp
+++ b/src/quick/designer/qqmldesignermetaobject.cpp
@@ -151,7 +151,7 @@ void QQmlDesignerMetaObject::init(QObject *object, QQmlEngine *engine)
 }
 
 QQmlDesignerMetaObject::QQmlDesignerMetaObject(QObject *object, QQmlEngine *engine)
-    : QQmlVMEMetaObject(object, cacheForObject(object, engine), vMEMetaDataForObject(object)),
+    : QQmlVMEMetaObject(QQmlEnginePrivate::getV4Engine(engine), object, cacheForObject(object, engine), vMEMetaDataForObject(object)),
       m_context(engine->contextForObject(object)),
       m_data(new MetaPropertyData),
       m_cache(0)
diff --git a/src/quick/designer/qquickdesignersupportitems.cpp b/src/quick/designer/qquickdesignersupportitems.cpp
index 4f23fe663..d10dbc48f 100644
--- a/src/quick/designer/qquickdesignersupportitems.cpp
+++ b/src/quick/designer/qquickdesignersupportitems.cpp
@@ -161,29 +161,24 @@ static bool isWindow(QObject *object) {
     return false;
 }
 
-static QQmlType *getQmlType(const QString &typeName, int majorNumber, int minorNumber)
+static bool isCrashingType(const QQmlType &type)
 {
-     return QQmlMetaType::qmlType(typeName, majorNumber, minorNumber);
-}
+    QString name = type.qmlTypeName();
 
-static bool isCrashingType(QQmlType *type)
-{
-    if (type) {
-        if (type->qmlTypeName() == QStringLiteral("QtMultimedia/MediaPlayer"))
-            return true;
+    if (name == QStringLiteral("QtMultimedia/MediaPlayer"))
+        return true;
 
-        if (type->qmlTypeName() == QStringLiteral("QtMultimedia/Audio"))
-            return true;
+    if (name == QStringLiteral("QtMultimedia/Audio"))
+        return true;
 
-        if (type->qmlTypeName() == QStringLiteral("QtQuick.Controls/MenuItem"))
-            return true;
+    if (name == QStringLiteral("QtQuick.Controls/MenuItem"))
+        return true;
 
-        if (type->qmlTypeName() == QStringLiteral("QtQuick.Controls/Menu"))
-            return true;
+    if (name == QStringLiteral("QtQuick.Controls/Menu"))
+        return true;
 
-        if (type->qmlTypeName() == QStringLiteral("QtQuick/Timer"))
-            return true;
-    }
+    if (name == QStringLiteral("QtQuick/Timer"))
+        return true;
 
     return false;
 }
@@ -195,19 +190,19 @@ QObject *QQuickDesignerSupportItems::createPrimitive(const QString &typeName, in
     Q_UNUSED(disableComponentComplete)
 
     QObject *object = 0;
-    QQmlType *type = getQmlType(typeName, majorNumber, minorNumber);
+    QQmlType type = QQmlMetaType::qmlType(typeName, majorNumber, minorNumber);
 
     if (isCrashingType(type)) {
         object = new QObject;
-    } else if (type) {
-        if ( type->isComposite()) {
-             object = createComponent(type->sourceUrl(), context);
+    } else if (type.isValid()) {
+        if ( type.isComposite()) {
+             object = createComponent(type.sourceUrl(), context);
         } else
         {
-            if (type->typeName() == "QQmlComponent") {
+            if (type.typeName() == "QQmlComponent") {
                 object = new QQmlComponent(context->engine(), 0);
             } else  {
-                object = type->create();
+                object = type.create();
             }
         }
 
diff --git a/src/quick/designer/qquickdesignersupportmetainfo.cpp b/src/quick/designer/qquickdesignersupportmetainfo.cpp
index c6c7ed38b..8ba07fbb8 100644
--- a/src/quick/designer/qquickdesignersupportmetainfo.cpp
+++ b/src/quick/designer/qquickdesignersupportmetainfo.cpp
@@ -46,8 +46,8 @@ bool QQuickDesignerSupportMetaInfo::isSubclassOf(QObject *object, const QByteArr
     const QMetaObject *metaObject = object->metaObject();
 
     while (metaObject) {
-         QQmlType *qmlType =  QQmlMetaType::qmlType(metaObject);
-         if (qmlType && qmlType->qmlTypeName() == QLatin1String(superTypeName)) // ignore version numbers
+         QQmlType qmlType =  QQmlMetaType::qmlType(metaObject);
+         if (qmlType.qmlTypeName() == QLatin1String(superTypeName)) // ignore version numbers
              return true;
 
          if (metaObject->className() == superTypeName)
diff --git a/tests/auto/qml/debugger/qqmlenginedebugservice/tst_qqmlenginedebugservice.cpp b/tests/auto/qml/debugger/qqmlenginedebugservice/tst_qqmlenginedebugservice.cpp
index bc3220ad8..aa3131a84 100644
--- a/tests/auto/qml/debugger/qqmlenginedebugservice/tst_qqmlenginedebugservice.cpp
+++ b/tests/auto/qml/debugger/qqmlenginedebugservice/tst_qqmlenginedebugservice.cpp
@@ -181,8 +181,8 @@ void tst_QQmlEngineDebugService::recursiveObjectTest(
 {
     const QMetaObject *meta = o->metaObject();
 
-    QQmlType *type = QQmlMetaType::qmlType(meta);
-    QString className = type ? QString(type->qmlTypeName())
+    QQmlType type = QQmlMetaType::qmlType(meta);
+    QString className = type.isValid() ? QString(type.qmlTypeName())
                              : QString(meta->className());
     className = className.mid(className.lastIndexOf(QLatin1Char('/'))+1);
 
diff --git a/tests/auto/qml/qqmlmetatype/tst_qqmlmetatype.cpp b/tests/auto/qml/qqmlmetatype/tst_qqmlmetatype.cpp
index 27e92f67a..4b9452f36 100644
--- a/tests/auto/qml/qqmlmetatype/tst_qqmlmetatype.cpp
+++ b/tests/auto/qml/qqmlmetatype/tst_qqmlmetatype.cpp
@@ -126,14 +126,14 @@ void tst_qqmlmetatype::initTestCase()
 
 void tst_qqmlmetatype::qmlParserStatusCast()
 {
-    QVERIFY(!QQmlMetaType::qmlType(QVariant::Int));
-    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<TestType *>()) != 0);
-    QCOMPARE(QQmlMetaType::qmlType(qMetaTypeId<TestType *>())->parserStatusCast(), -1);
-    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<ValueSourceTestType *>()) != 0);
-    QCOMPARE(QQmlMetaType::qmlType(qMetaTypeId<ValueSourceTestType *>())->parserStatusCast(), -1);
-
-    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<ParserStatusTestType *>()) != 0);
-    int cast = QQmlMetaType::qmlType(qMetaTypeId<ParserStatusTestType *>())->parserStatusCast();
+    QVERIFY(!QQmlMetaType::qmlType(QVariant::Int).isValid());
+    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<TestType *>()).isValid());
+    QCOMPARE(QQmlMetaType::qmlType(qMetaTypeId<TestType *>()).parserStatusCast(), -1);
+    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<ValueSourceTestType *>()).isValid());
+    QCOMPARE(QQmlMetaType::qmlType(qMetaTypeId<ValueSourceTestType *>()).parserStatusCast(), -1);
+
+    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<ParserStatusTestType *>()).isValid());
+    int cast = QQmlMetaType::qmlType(qMetaTypeId<ParserStatusTestType *>()).parserStatusCast();
     QVERIFY(cast != -1);
     QVERIFY(cast != 0);
 
@@ -146,14 +146,14 @@ void tst_qqmlmetatype::qmlParserStatusCast()
 
 void tst_qqmlmetatype::qmlPropertyValueSourceCast()
 {
-    QVERIFY(!QQmlMetaType::qmlType(QVariant::Int));
-    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<TestType *>()) != 0);
-    QCOMPARE(QQmlMetaType::qmlType(qMetaTypeId<TestType *>())->propertyValueSourceCast(), -1);
-    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<ParserStatusTestType *>()) != 0);
-    QCOMPARE(QQmlMetaType::qmlType(qMetaTypeId<ParserStatusTestType *>())->propertyValueSourceCast(), -1);
-
-    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<ValueSourceTestType *>()) != 0);
-    int cast = QQmlMetaType::qmlType(qMetaTypeId<ValueSourceTestType *>())->propertyValueSourceCast();
+    QVERIFY(!QQmlMetaType::qmlType(QVariant::Int).isValid());
+    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<TestType *>()).isValid());
+    QCOMPARE(QQmlMetaType::qmlType(qMetaTypeId<TestType *>()).propertyValueSourceCast(), -1);
+    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<ParserStatusTestType *>()).isValid());
+    QCOMPARE(QQmlMetaType::qmlType(qMetaTypeId<ParserStatusTestType *>()).propertyValueSourceCast(), -1);
+
+    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<ValueSourceTestType *>()).isValid());
+    int cast = QQmlMetaType::qmlType(qMetaTypeId<ValueSourceTestType *>()).propertyValueSourceCast();
     QVERIFY(cast != -1);
     QVERIFY(cast != 0);
 
@@ -166,14 +166,14 @@ void tst_qqmlmetatype::qmlPropertyValueSourceCast()
 
 void tst_qqmlmetatype::qmlPropertyValueInterceptorCast()
 {
-    QVERIFY(!QQmlMetaType::qmlType(QVariant::Int));
-    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<TestType *>()) != 0);
-    QCOMPARE(QQmlMetaType::qmlType(qMetaTypeId<TestType *>())->propertyValueInterceptorCast(), -1);
-    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<ParserStatusTestType *>()) != 0);
-    QCOMPARE(QQmlMetaType::qmlType(qMetaTypeId<ParserStatusTestType *>())->propertyValueInterceptorCast(), -1);
-
-    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<ValueInterceptorTestType *>()) != 0);
-    int cast = QQmlMetaType::qmlType(qMetaTypeId<ValueInterceptorTestType *>())->propertyValueInterceptorCast();
+    QVERIFY(!QQmlMetaType::qmlType(QVariant::Int).isValid());
+    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<TestType *>()).isValid());
+    QCOMPARE(QQmlMetaType::qmlType(qMetaTypeId<TestType *>()).propertyValueInterceptorCast(), -1);
+    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<ParserStatusTestType *>()).isValid());
+    QCOMPARE(QQmlMetaType::qmlType(qMetaTypeId<ParserStatusTestType *>()).propertyValueInterceptorCast(), -1);
+
+    QVERIFY(QQmlMetaType::qmlType(qMetaTypeId<ValueInterceptorTestType *>()).isValid());
+    int cast = QQmlMetaType::qmlType(qMetaTypeId<ValueInterceptorTestType *>()).propertyValueInterceptorCast();
     QVERIFY(cast != -1);
     QVERIFY(cast != 0);
 
@@ -186,17 +186,17 @@ void tst_qqmlmetatype::qmlPropertyValueInterceptorCast()
 
 void tst_qqmlmetatype::qmlType()
 {
-    QQmlType *type = QQmlMetaType::qmlType(QString("ParserStatusTestType"), QString("Test"), 1, 0);
-    QVERIFY(type);
-    QVERIFY(type->module() == QLatin1String("Test"));
-    QVERIFY(type->elementName() == QLatin1String("ParserStatusTestType"));
-    QCOMPARE(type->qmlTypeName(), QLatin1String("Test/ParserStatusTestType"));
+    QQmlType type = QQmlMetaType::qmlType(QString("ParserStatusTestType"), QString("Test"), 1, 0);
+    QVERIFY(type.isValid());
+    QVERIFY(type.module() == QLatin1String("Test"));
+    QVERIFY(type.elementName() == QLatin1String("ParserStatusTestType"));
+    QCOMPARE(type.qmlTypeName(), QLatin1String("Test/ParserStatusTestType"));
 
     type = QQmlMetaType::qmlType("Test/ParserStatusTestType", 1, 0);
-    QVERIFY(type);
-    QVERIFY(type->module() == QLatin1String("Test"));
-    QVERIFY(type->elementName() == QLatin1String("ParserStatusTestType"));
-    QCOMPARE(type->qmlTypeName(), QLatin1String("Test/ParserStatusTestType"));
+    QVERIFY(type.isValid());
+    QVERIFY(type.module() == QLatin1String("Test"));
+    QVERIFY(type.elementName() == QLatin1String("ParserStatusTestType"));
+    QCOMPARE(type.qmlTypeName(), QLatin1String("Test/ParserStatusTestType"));
 }
 
 void tst_qqmlmetatype::invalidQmlTypeName()
@@ -240,23 +240,23 @@ void tst_qqmlmetatype::defaultObject()
 
 void tst_qqmlmetatype::registrationType()
 {
-    QQmlType *type = QQmlMetaType::qmlType(QString("TestType"), QString("Test"), 1, 0);
-    QVERIFY(type);
-    QVERIFY(!type->isInterface());
-    QVERIFY(!type->isSingleton());
-    QVERIFY(!type->isComposite());
+    QQmlType type = QQmlMetaType::qmlType(QString("TestType"), QString("Test"), 1, 0);
+    QVERIFY(type.isValid());
+    QVERIFY(!type.isInterface());
+    QVERIFY(!type.isSingleton());
+    QVERIFY(!type.isComposite());
 
     type = QQmlMetaType::qmlType(QString("TestTypeSingleton"), QString("Test"), 1, 0);
-    QVERIFY(type);
-    QVERIFY(!type->isInterface());
-    QVERIFY(type->isSingleton());
-    QVERIFY(!type->isComposite());
+    QVERIFY(type.isValid());
+    QVERIFY(!type.isInterface());
+    QVERIFY(type.isSingleton());
+    QVERIFY(!type.isComposite());
 
     type = QQmlMetaType::qmlType(QString("TestTypeComposite"), QString("Test"), 1, 0);
-    QVERIFY(type);
-    QVERIFY(!type->isInterface());
-    QVERIFY(!type->isSingleton());
-    QVERIFY(type->isComposite());
+    QVERIFY(type.isValid());
+    QVERIFY(!type.isInterface());
+    QVERIFY(!type.isSingleton());
+    QVERIFY(type.isComposite());
 }
 
 void tst_qqmlmetatype::compositeType()
@@ -268,12 +268,12 @@ void tst_qqmlmetatype::compositeType()
     QObject* obj = c.create();
     QVERIFY(obj);
 
-    QQmlType *type = QQmlMetaType::qmlType(QString("ImplicitType"), QString(""), 1, 0);
-    QVERIFY(type);
-    QVERIFY(type->module().isEmpty());
-    QCOMPARE(type->elementName(), QLatin1String("ImplicitType"));
-    QCOMPARE(type->qmlTypeName(), QLatin1String("ImplicitType"));
-    QCOMPARE(type->sourceUrl(), testFileUrl("ImplicitType.qml"));
+    QQmlType type = QQmlMetaType::qmlType(QString("ImplicitType"), QString(""), 1, 0);
+    QVERIFY(type.isValid());
+    QVERIFY(type.module().isEmpty());
+    QCOMPARE(type.elementName(), QLatin1String("ImplicitType"));
+    QCOMPARE(type.qmlTypeName(), QLatin1String("ImplicitType"));
+    QCOMPARE(type.sourceUrl(), testFileUrl("ImplicitType.qml"));
 }
 
 QTEST_MAIN(tst_qqmlmetatype)
